Index: contrib/MacPorts_Framework/MPPortProcess.m
===================================================================
--- contrib/MacPorts_Framework/MPPortProcess.m	(revision 65491)
+++ contrib/MacPorts_Framework/MPPortProcess.m	(revision 65491)
@@ -0,0 +1,104 @@
+//
+//  MPPortProcess.m
+//  MacPorts.Framework
+//
+//  Created by Juan Germán Castañeda Echevarría on 7/9/09.
+//  Copyright 2009 UNAM. All rights reserved.
+//
+
+#import "MPPortProcess.h"
+#import "SimpleLog.h"
+
+@interface MPPortProcess (PrivateMethods)
+
+- (void)initializeInterpreter;
+
+@end
+
+@implementation MPPortProcess
+
+- (id)initWithPKGPath:(NSString*)pkgPath {
+    PKGPath = pkgPath;
+    [self initializeInterpreter];
+    return self;
+}
+
+- (oneway void)evaluateString:(bycopy id)statement {
+    // TODO Handle the posible errors and notifications
+    int retCode = Tcl_Eval(interpreter, [statement UTF8String]);
+    if (retCode != TCL_OK) {
+        Tcl_Obj * interpObj = Tcl_GetObjResult(interpreter);
+        int length, errCode;
+        NSString * errString = [NSString stringWithUTF8String:Tcl_GetStringFromObj(interpObj, &length)];
+        errCode = Tcl_GetErrno();
+    
+        NSLog(@"- %@ - %i", errString, errCode);
+        exit(errCode);
+    }
+    
+    exit(retCode);
+}
+
+
+#pragma mark Private Methods
+
+- (void)initializeInterpreter {
+    // Create interpreter
+    interpreter = Tcl_CreateInterp();
+	if(interpreter == NULL) {
+		NSLog(@"Error in Tcl_CreateInterp, aborting.");
+	}
+    // Initialize interpreter
+    if(Tcl_Init(interpreter) == TCL_ERROR) {
+		NSLog(@"Error in Tcl_Init: %s", Tcl_GetStringResult(interpreter));
+		Tcl_DeleteInterp(interpreter);
+	}
+    // Load macports_fastload.tcl from PKGPath/macports1.0
+    NSString * mport_fastload = [[@"source [file join \"" stringByAppendingString:PKGPath]
+								 stringByAppendingString:@"\" macports1.0 macports_fastload.tcl]"];
+	if(Tcl_Eval(interpreter, [mport_fastload UTF8String]) == TCL_ERROR) {
+		NSLog(@"Error in Tcl_EvalFile macports_fastload.tcl: %s", Tcl_GetStringResult(interpreter));
+		Tcl_DeleteInterp(interpreter);
+	}
+    // Load notifications methods
+    Tcl_CreateObjCommand(interpreter, "simplelog", SimpleLog_Command, NULL, NULL);
+	if (Tcl_PkgProvide(interpreter, "simplelog", "1.0") != TCL_OK) {
+		NSLog(@"Error in Tcl_PkgProvide: %s", Tcl_GetStringResult(interpreter));
+	}
+    // Load portProcessInit.tcl
+    NSString *portProcessInitPath = @"portProcessInit.tcl";
+    if( Tcl_EvalFile(interpreter, [portProcessInitPath UTF8String]) == TCL_ERROR) {
+		NSLog(@"Error in Tcl_EvalFile portProcessInit.tcl: %s", Tcl_GetStringResult(interpreter));
+		Tcl_DeleteInterp(interpreter);
+	}
+}
+
+@end
+
+int main(int argc, char const * argv[]) {
+    NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
+    
+    NSConnection *portProcessConnection; 
+    portProcessConnection = [NSConnection defaultConnection];
+    NSString *PKGPath = [[NSString alloc] initWithCString:argv[1] encoding:NSUTF8StringEncoding];
+//    NSString *portProcessInitPath = [[NSString alloc] initWithCString:argv[2] encoding:NSUTF8StringEncoding];
+    
+    MPPortProcess *portProcess = [[MPPortProcess alloc] initWithPKGPath:PKGPath];
+    
+    // Vending portProcess
+    [portProcessConnection setRootObject:portProcess];
+    
+    // Register the named connection
+    if ( [portProcessConnection registerName:@"MPPortProcess"] ) {
+        NSLog( @"Successfully registered connection with port %@", 
+              [[portProcessConnection receivePort] description] );
+    } else {
+        NSLog( @"Name used by %@", 
+              [[[NSPortNameServer systemDefaultPortNameServer] portForName:@"MPPortProcess"] description] );
+    }
+    
+    // Wait for any message
+    [[NSRunLoop currentRunLoop] run];
+  	[pool release];
+    return 0;
+}
Index: contrib/MacPorts_Framework/MPRegistry.h
===================================================================
--- contrib/MacPorts_Framework/MPRegistry.h	(revision 40518)
+++ contrib/MacPorts_Framework/MPRegistry.h	(revision 65491)
@@ -61,5 +61,5 @@
 
 /*
- @brief Calls [self installed:name version:@""]
+ @brief Calls [self installed:name withVersion:@""]
  @param name Text to match the port name
  */
Index: contrib/MacPorts_Framework/SimpleLog.h
===================================================================
--- contrib/MacPorts_Framework/SimpleLog.h	(revision 65491)
+++ contrib/MacPorts_Framework/SimpleLog.h	(revision 65491)
@@ -0,0 +1,12 @@
+/*
+ *  SimpleLog.h
+ *  MacPorts.Framework
+ *
+ *  Created by Juan Germán Castañeda Echevarría on 7/21/09.
+ *  Copyright 2009 UNAM. All rights reserved.
+ *
+ */
+
+#include <tcl.h>
+
+int SimpleLog_Command(ClientData clientData, Tcl_Interp *interpreter, int objc, Tcl_Obj *CONST objv[]);
Index: contrib/MacPorts_Framework/SimpleLog.m
===================================================================
--- contrib/MacPorts_Framework/SimpleLog.m	(revision 65491)
+++ contrib/MacPorts_Framework/SimpleLog.m	(revision 65491)
@@ -0,0 +1,76 @@
+/*
+ *  SimpleLog.m
+ *  MacPorts.Framework
+ *
+ *  Created by Juan Germán Castañeda Echevarría on 7/21/09.
+ *  Copyright 2009 UNAM. All rights reserved.
+ *
+ */
+
+#include "SimpleLog.h"
+
+#define MPSEPARATOR @"_&MP&_"
+
+int SimpleLog_Command(ClientData clientData, Tcl_Interp *interpreter, int objc, Tcl_Obj *CONST objv[]) {
+    int tclResult = TCL_ERROR;
+	NSMutableString * data;
+	
+	++objv, --objc;
+	
+	if (objc) {
+		int tclCount;
+		const char **tclElements;
+		
+		tclResult = Tcl_SplitList(interpreter, Tcl_GetString(*objv), &tclCount, &tclElements);
+		
+		
+		if (tclResult == TCL_OK) {
+			if (tclCount > 0) {
+                NSLog([NSString stringWithUTF8String:tclElements[0]]);
+				data = [NSMutableString stringWithUTF8String:tclElements[0]];
+				[data appendString:MPSEPARATOR];
+				
+				if(tclCount > 1 && tclElements[1]) {
+                    NSLog([NSString stringWithUTF8String:tclElements[1]]);
+					[data appendString:[NSString stringWithUTF8String:tclElements[1]]];
+					[data appendString:MPSEPARATOR];
+				}
+				else {
+					[data appendString:@"None"];
+					[data appendString:MPSEPARATOR];
+				}
+				
+				if(tclCount > 2 && tclElements[2]) {
+                    NSLog([NSString stringWithUTF8String:tclElements[2]]);
+					[data appendString:[NSString stringWithUTF8String:tclElements[2]]];
+					[data appendString:MPSEPARATOR];
+				}
+				else {
+					[data appendString:@"None"];
+					[data appendString:MPSEPARATOR];
+				}
+			}
+			else {
+				data = [NSMutableString stringWithFormat:@"None%@None%@None%@", MPSEPARATOR, MPSEPARATOR, MPSEPARATOR ];
+			}
+		}
+	}
+    
+    //Now get the actual message
+    ++objv; --objc;
+    if (objc) {
+        [data appendString:[NSString stringWithUTF8String:Tcl_GetString(*objv)]];
+    }
+    else {
+        [data appendString:@"None"];
+    }
+    
+    id theProxy = [NSConnection
+                   rootProxyForConnectionWithRegisteredName:@"MPNotifications"
+                   host:nil];
+    [theProxy sendIPCNotification:data];
+    
+    NSLog(@"-----%@", data);
+    
+	return tclResult;
+}
Index: contrib/MacPorts_Framework/init.tcl
===================================================================
--- contrib/MacPorts_Framework/init.tcl	(revision 40518)
+++ contrib/MacPorts_Framework/init.tcl	(revision 65491)
@@ -5,5 +5,5 @@
 #Set ui_options to log all messages to stdout and notify system
 #filtering is done on the Obj-C side of things
-set ui_options(ports_debug) "yes"
+# set ui_options(ports_debug) "yes"
 set ui_options(ports_verbose) "yes"
 
@@ -52,13 +52,13 @@
             } else {
                 return {}
-			}
-		}
+            }
+        }
         msg {
             if {[ui_isset ports_quiet]} {
-                return {}
-			} else {
-				return {stdout}
-			}
-		}
+              return {}
+            } else {
+              return {stdout}
+            }
+        }
         error {
         	return {stderr}
@@ -77,71 +77,80 @@
 #This is currently under works ... a reasonable solution
 #should be coming up soon
-proc ui_init {priority prefix channels message} {
-	switch $priority {
-		msg {
-			set nottype "MPMsgNotification" 
-		}
-		debug {
-			set "MPDebugNotification"
-			puts "Recieved Debug"
-		}
-		warn {
-			set nottype "MPWarnNotification"
-		}
-		error {
-			set nottype "MPErrorNotification"
-			puts "Recieved Error"
-		}
-		info {
-			set nottype "MPInfoNotification"
-			puts "Recieved Info"
-		}
-		default {
-			set nottype "MPDefaultNotification"
-		}	
-	}
-	
+proc macports::ui_init {priority args} {
+    switch $priority {
+  		msg {
+  			set nottype "MPMsgNotification" 
+  		}
+  		debug {
+  			set nottype "MPDebugNotification"
+  			puts "Recieved Debug"
+  		}
+  		warn {
+  			set nottype "MPWarnNotification"
+  		}
+  		error {
+  			set nottype "MPErrorNotification"
+  			puts "Recieved Error"
+  		}
+  		info {
+  			set nottype "MPInfoNotification"
+  			puts "Recieved Info"
+  		}
+  		default {
+  			set nottype "MPDefaultNotification"
+  		}	
+  	}
+  
     # Get the list of channels.
-    try {
+    if {[llength [info commands ui_channels]] > 0} {
         set channels [ui_channels $priority]
-    } catch * {
+    } else {
         set channels [ui_channels_default $priority]
     }
-    
-    #set channels [ui_channels $priority]
-    
+
     # Simplify ui_$priority.
     set nbchans [llength $channels]
     if {$nbchans == 0} {
-        proc ::ui_$priority {str} [subst {
-        	notifications send $nottype "$chan $prefix" "\$str"
+        proc ::ui_$priority {args} [subst {
+          notifications send $nottype "$chan $prefix" "\$str"
         }]
     } else {
-        try {
+        if {[llength [info commands ui_prefix]] > 0} {
             set prefix [ui_prefix $priority]
-        } catch * {
+        } else {
             set prefix [ui_prefix_default $priority]
         }
-        
-        #set prefix [ui_prefix $priority]
-        
-        if {$nbchans == 1} {
-            set chan [lindex $channels 0]
-            
-            proc ::ui_$priority {str} [subst { 
-            	puts $chan "$prefix\$str"
-            	notifications send $nottype "$chan $prefix" "\$str"
-            }]
+
+        if {[llength [info commands ::ui_init]] > 0} {
+            eval ::ui_init $priority $prefix $channels $args
         } else {
-        	proc ::ui_$priority {str} [subst {
-        		foreach chan \$channels {
-        			puts $chan "$prefix\$str"
-        			notifications send $nottype "$chan $prefix" "\$str"
-        		}
-        	}]
-        }
-        
-    # Call ui_$priority - Is this step necessary? Consult with Randall
-    #::ui_$priority $message
+            if {$nbchans == 1} {
+                set chan [lindex $channels 0]
+                proc ::ui_$priority {args} [subst {
+                  if {\[lindex \$args 0\] == "-nonewline"} {
+                    puts $chan "$prefix\[lindex \$args 1\]"
+                    notifications send $nottype "$chan $prefix" "\[lindex \$args 1\]"
+                  } else {
+                    puts -nonewline $chan "$prefix\[lindex \$args 1\]"
+                    notifications send $nottype "$chan $prefix" "\[lindex \$args 0\]"
+                  }
+                }]
+            } else {
+                proc ::ui_$priority {args} [subst {
+                    foreach chan \$channels {
+                      if {\[lindex \$args 0\] == "-nonewline"} {
+                        puts $chan "$prefix\[lindex \$args 1\]"
+                        notifications send $nottype "$chan $prefix" "\[lindex \$args 1\]"
+                      } else {
+                        puts -nonewline $chan "$prefix\[lindex \$args 1\]"
+                        notifications send $nottype "$chan $prefix" "\[lindex \$args 0\]"
+                      }
+                    }
+                }]
+            }
+        }
+
+        # Call ui_$priority
+        eval ::ui_$priority $args
     }
 }
@@ -151,5 +160,5 @@
 #and log error Information in a similar fashion to code
 #in macports.tcl.
-proc mportuninstall {portname {v ""} optionslist} {
+proc mportuninstall {portname {v ""} {optionslist ""}} {
 	if {[catch {portuninstall::uninstall $portname $v $optionslist} result]} {
 		
@@ -181,4 +190,14 @@
 }
 
+proc mportupgrade {portname} {
+    array set depscache {}
+	if {[catch {macports::upgrade $portname "port:$portname" [array get global_variations] [array get variations] [array get options] depscache} result]} {
+			
+			global errorInfo
+			ui_debug "$errorInfo"
+			ui_error "Upgrade $portname failed: $result"
+			return 1
+	}
+}
 
 
Index: contrib/MacPorts_Framework/interpInit.tcl
===================================================================
--- contrib/MacPorts_Framework/interpInit.tcl	(revision 40518)
+++ contrib/MacPorts_Framework/interpInit.tcl	(revision 65491)
@@ -53,13 +53,13 @@
             } else {
                 return {}
-			}
-		}
+            }
+        }
         msg {
             if {[ui_isset ports_quiet]} {
-                return {}
-			} else {
-				return {stdout}
-			}
-		}
+              return {}
+            } else {
+              return {stdout}
+            }
+        }
         error {
         	return {stderr}
@@ -77,35 +77,33 @@
 #This is currently under works ... a reasonable solution
 #should be coming up soon
-proc ui_init {priority prefix channels message} {
-	#puts "INSIDE ui_init priority with prefix $prefix and message $message"
-	
-	switch $priority {
-		msg {
-			set nottype "MPMsgNotification" 
-		}
-		debug {
-			set "MPDebugNotification"
-			puts "Recieved Debug"
-		}
-		warn {
-			set nottype "MPWarnNotification"
-		}
-		error {
-			set nottype "MPErrorNotification"
-			puts "Recieved Error"
-		}
-		info {
-			set nottype "MPInfoNotification"
-			puts "Recieved Info"
-		}
-		default {
-			set nottype "MPDefaultNotification"
-		}	
-	}
-	
+proc macports::ui_init {priority args} {
+    switch $priority {
+      msg {
+        set nottype "MPMsgNotification" 
+      }
+      debug {
+        set nottype "MPDebugNotification"
+        puts "Recieved Debug"
+      }
+      warn {
+        set nottype "MPWarnNotification"
+      }
+      error {
+        set nottype "MPErrorNotification"
+        puts "Recieved Error"
+      }
+      info {
+        set nottype "MPInfoNotification"
+        puts "Recieved Info"
+      }
+      default {
+        set nottype "MPDefaultNotification"
+      }
+    }
+
     # Get the list of channels.
-    try {
+    if {[llength [info commands ui_channels]] > 0} {
         set channels [ui_channels $priority]
-    } catch * {
+    } else {
         set channels [ui_channels_default $priority]
     }
@@ -117,33 +115,45 @@
     if {$nbchans == 0} {
         proc ::ui_$priority {str} [subst {
-        	simplelog "$nottype $chan $prefix" "\$str" 
+          simplelog "$nottype $chan $prefix" "\$str" 
         }]
     } else {
-        try {
-            set prefix [ui_prefix $priority]
-        } catch * {
-            set prefix [ui_prefix_default $priority]
-        }
-        
-        #set prefix [ui_prefix $priority]
-        
+      if {[llength [info commands ui_prefix]] > 0} {
+          set prefix [ui_prefix $priority]
+      } else {
+          set prefix [ui_prefix_default $priority]
+      }
+
+      if {[llength [info commands ::ui_init]] > 0} {
+          eval ::ui_init $priority $prefix $channels $args
+      } else {
         if {$nbchans == 1} {
-            set chan [lindex $channels 0]
-            
-            proc ::ui_$priority {str} [subst { 
-            	puts $chan "$prefix\$str"
-            	simplelog "$nottype $chan $prefix" "\$str" 
-            }]
+          set chan [lindex $channels 0]
+
+          proc ::ui_$priority {args} [subst {
+            if {\[lindex \$args 0\] == "-nonewline"} {
+              puts $chan "$prefix\[lindex \$args 1\]"
+              simplelog "$nottype $chan $prefix" "\[lindex \$args 1\]"
+            } else {
+              puts -nonewline $chan "$prefix\[lindex \$args 1\]"
+              simplelog "$nottype $chan $prefix" "\[lindex \$args 0\]"
+            }
+          }]
         } else {
-        	proc ::ui_$priority {str} [subst {
-        		foreach chan \$channels {
-        			puts $chan "$prefix\$str"
-        			simplelog "$nottype $chan $prefix" "\$str" 
-        		}
-        	}]
-        }
-        
-    # Call ui_$priority - Is this step necessary? Consult with Randall
-    #::ui_$priority $message
+          proc ::ui_$priority {args} [subst {
+            foreach chan \$channels {
+              if {\[lindex \$args 0\] == "-nonewline"} {
+                puts $chan "$prefix\[lindex \$args 1\]"
+                simplelog "$nottype $chan $prefix" "\[lindex \$args 1\]"
+              } else {
+                puts -nonewline $chan "$prefix\[lindex \$args 1\]"
+                simplelog "$nottype $chan $prefix" "\[lindex \$args 0\]"
+              }
+            }
+          }]
+        }
+      }
+
+      # Call ui_$priority
+      eval ::ui_$priority $args
     }
 }
@@ -184,5 +194,14 @@
 }
 
-
+proc mportupgrade {portname} {
+    array set depscache {}
+	if {[catch {macports::upgrade $portname "port:$portname" [array get global_variations] [array get variations] [array get options] depscache} result]} {
+			
+			global errorInfo
+			ui_debug "$errorInfo"
+			ui_error "Upgrade $portname failed: $result"
+			return 1
+	}
+}
 
 # Initialize dport
Index: contrib/MacPorts_Framework/portProcessInit.tcl
===================================================================
--- contrib/MacPorts_Framework/portProcessInit.tcl	(revision 65491)
+++ contrib/MacPorts_Framework/portProcessInit.tcl	(revision 65491)
@@ -0,0 +1,211 @@
+package require macports
+package require simplelog
+
+
+
+#Set ui_options to log all messages to stdout and notify system
+#filtering is done on the Obj-C side of things
+set ui_options(ports_debug) "yes"
+set ui_options(ports_verbose) "yes"
+
+# ui_options accessor
+proc ui_isset {val} {
+	global ui_options
+	if {[info exists ui_options($val)]} {
+		if {$ui_options($val) == "yes"} {
+			return 1
+		}
+	}
+	return 0
+}
+
+# UI Callback
+proc ui_prefix {priority} {
+    switch $priority {
+        debug {
+        	return "DEBUG: "
+        }
+        error {
+        	return "Error: "
+        }
+        warn {
+        	return "Warning: "
+        }
+        default {
+        	return ""
+        }
+    }
+}
+
+proc ui_channels {priority} {
+    global logfd
+    switch $priority {
+        debug {
+            if {[ui_isset ports_debug]} {
+            	return {stderr}
+            } else {
+            	return {}
+            }
+        }
+        info {
+            if {[ui_isset ports_verbose]} {
+                return {stdout}
+            } else {
+                return {}
+			}
+		}
+        msg {
+            if {[ui_isset ports_quiet]} {
+                return {}
+			} else {
+				return {stdout}
+			}
+		}
+        error {
+        	return {stderr}
+        }
+        default {
+        	return {stdout}
+        }
+    }
+}
+
+
+
+#Modifying UI initialization to enable notifications
+#Redefine ui_$pritority to throw global notifications
+#This is currently under works ... a reasonable solution
+#should be coming up soon
+proc macports::ui_init {priority args} {
+    switch $priority {
+  		msg {
+  			set nottype "MPMsgNotification" 
+  		}
+  		debug {
+  			set nottype "MPDebugNotification"
+  			puts "Recieved Debug"
+  		}
+  		warn {
+  			set nottype "MPWarnNotification"
+  		}
+  		error {
+  			set nottype "MPErrorNotification"
+  			puts "Recieved Error"
+  		}
+  		info {
+  			set nottype "MPInfoNotification"
+  			puts "Recieved Info"
+  		}
+  		default {
+  			set nottype "MPDefaultNotification"
+  		}	
+  	}
+  
+    # Get the list of channels.
+    if {[llength [info commands ui_channels]] > 0} {
+        set channels [ui_channels $priority]
+    } else {
+        set channels [ui_channels_default $priority]
+    }
+
+    # Simplify ui_$priority.
+    set nbchans [llength $channels]
+    if {$nbchans == 0} {
+        proc ::ui_$priority {args} [subst {
+          simplelog "$nottype $chan $prefix" "\$str"
+        }]
+    } else {
+        if {[llength [info commands ui_prefix]] > 0} {
+            set prefix [ui_prefix $priority]
+        } else {
+            set prefix [ui_prefix_default $priority]
+        }
+
+        if {[llength [info commands ::ui_init]] > 0} {
+            eval ::ui_init $priority $prefix $channels $args
+        } else {
+            if {$nbchans == 1} {
+                set chan [lindex $channels 0]
+                proc ::ui_$priority {args} [subst {
+                  if {\[lindex \$args 0\] == "-nonewline"} {
+                    puts $chan "$prefix\[lindex \$args 1\]"
+                    simplelog "$nottype $chan $prefix" "\[lindex \$args 1\]"
+                  } else {
+                    puts -nonewline $chan "$prefix\[lindex \$args 1\]"
+                    simplelog "$nottype $chan $prefix" "\[lindex \$args 0\]"
+                  }
+                }]
+            } else {
+                proc ::ui_$priority {args} [subst {
+                    foreach chan \$channels {
+                      if {\[lindex \$args 0\] == "-nonewline"} {
+                        puts $chan "$prefix\[lindex \$args 1\]"
+                        simplelog "$nottype $chan $prefix" "\[lindex \$args 1\]"
+                      } else {
+                        puts -nonewline $chan "$prefix\[lindex \$args 1\]"
+                        simplelog "$nottype $chan $prefix" "\[lindex \$args 0\]"
+                      }
+                    }
+                }]
+            }
+        }
+
+        # Call ui_$priority
+        eval ::ui_$priority $args
+    }
+}
+
+
+#Wrapping the following API routines to catch errors
+#and log error Information in a similar fashion to code
+#in macports.tcl. Note optionslist is not being used for now
+set mp_empty_list [list]
+proc mportuninstall {portname {v ""} {optionslist ""} } {
+	if {[catch {portuninstall::uninstall $portname $v [array get options]} result]} {
+		
+			global errorInfo
+			ui_debug "$errorInfo"
+			ui_error "Uninstall $portname $v failed: $result"
+			return 1
+	}
+}
+
+proc mportactivate {portname {v ""} {optionslist ""}} {
+	if {[catch {portimage::activate $portname $v $optionslist} result]} {
+			
+			global errorInfo
+			ui_debug "$errorInfo"
+			ui_error "Activate $portname $v failed: $result"
+			return 1
+	}
+}
+
+proc mportdeactivate {portname {v ""} {optionslist ""} } {
+	if {[catch {portimage::deactivate $portname $v $optionslist} result]} {
+			
+			global errorInfo
+			ui_debug "$errorInfo"
+			ui_error "Deactivate $portname $v failed: $result"
+			return 1
+	}
+}
+
+proc mportupgrade {portname} {
+    array set depscache {}
+	if {[catch {macports::upgrade $portname "port:$portname" [array get global_variations] [array get variations] [array get options] depscache} result]} {
+			
+			global errorInfo
+			ui_debug "$errorInfo"
+			ui_error "Upgrade $portname failed: $result"
+			return 1
+	}
+}
+
+# Initialize dport
+# This must be done following parse of global options, as some options are
+# evaluated by dportinit.
+if {[catch {mportinit ui_options global_options global_variations} result]} {
+	global errorInfo
+	puts "$errorInfo"
+	fatal "Failed to initialize ports system, $result"
+}
